﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using TreeSharp;
using Kupo;
using Kupo.Settings;

using Action = TreeSharp.Action;
namespace Kupo.Rotations
{
    public class  MaruaderWarrior : KupoRoutine
    {
        public override void Initialize()
        {
            WindowSettings = new WarriorSettings();
            base.Initialize();
        }
        private WarriorSettings settings
        {
            get
            {
                return WindowSettings as WarriorSettings;
            }
        }

        public override int PullRange
        {
            get { return 5; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[]{ClassJobType.Marauder, ClassJobType.Warrior, };}
        }

        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        protected override Composite CreatePull()
        {
            return new PrioritySelector(
            EnsureTarget,

                 //Stop double casting due to delay
                new Decorator(r => Actionmanager.InSpellInRangeLOS(settings.PullSpell, Core.Target) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                new Decorator(r => Actionmanager.InSpellInRangeLOS(settings.PullSpell, Core.Target) == SpellRangeCheck.ErrorNotInFront, new Action(r => Core.Target.Face())),
                Apply(r => settings.PullSpell, r => Actionmanager.InSpellInRangeLOS(settings.PullSpell, Core.Target) == SpellRangeCheck.Success)
            );
        }

        protected override Composite CreateHeal()
        {
            return new PrioritySelector(
                Apply("Foresight", r => true && Core.Player.CurrentHealthPercent <= settings.ForesightHPPercent, r => Core.Player),
                Apply("Bloodbath", r => true && Core.Player.CurrentHealthPercent <= settings.BloodBathHPPercent, r => Core.Player),
                Apply("Convalescence", r => true && Core.Player.CurrentHealthPercent <= settings.ConvalescenceHPPercent, r => Core.Player),
                Apply("Thrill of Battle", r => true && Core.Player.CurrentHealthPercent <= settings.ThrillofBattleHPPercent, r => Core.Player),
                Apply("Featherfoot", r => true && Core.Player.CurrentHealthPercent <= settings.FeatherFootHPPercent, r => Core.Player)
            );
        }


        protected override Composite CreateCombat()
        {
            return new PrioritySelector(
                Apply("Defiance", r => true && settings.UseDefiance == true && !Core.Player.HasAura("Defiance"), r => Core.Player),
                Apply("Defiance", r => true && settings.UseDefiance == false && Core.Player.HasAura("Defiance"), r => Core.Player),
                Cast("Overpower", r => EnemiesNearTarget(7) >= 2 && Core.Player.CurrentTPPercent > settings.UseOPUntilTPPercent),
                Cast("Steel Cyclone", r=> true && EnemiesNearTarget(7) >= 2 && Core.Player.HasAura("Infuriated"), r=> Core.Player),
                Apply("Flash", r => true && settings.UseFlash == true && EnemiesNearTarget(7) >= 2 && Core.Player.CurrentManaPercent > settings.UseFlashUntilManaPercent, r => Core.Player),
                Apply("Fracture"),
                Cast("Brutal Swing", r => Core.Target.ToCharacter.IsCasting == true && settings.InterruptTarget == true),
                Cast("Mercy Stroke"),
				Cast("Storm's Eye", r => Actionmanager.LastSpell.Name == "Maim"),
				Cast("Butcher's Block", r => Actionmanager.LastSpell.Name == "Skull Sunder"),
                Cast("Maim", r => Actionmanager.LastSpellId ==  31 && !Core.Player.HasAura("Maim")),
				Apply("Berserk", r => true && settings.UseBerserk == true, r => Core.Player),
                Cast("Inner Beast", r => Core.Player.HasAura("Infuriated")),
                Cast("Skull Sunder", r => Actionmanager.LastSpell.Name == "Heavy Swing"),
                Cast("Heavy Swing")
            );
        }

    }
}
